import numpy as np
import scipy as scp

#simple gradient descent
#func: a function hander with input x, output function val & gradient
#init_step: the initial scale of step size
#max_iter: maximum number of iterations
#tol: the tolrence level---if function value changes is no bigger than tolrence level then stop
def simple_gd(func, x, init_step=1e-4, verbose = True, max_iter = 100, tol=1e-6):
    gamma = init_step
    f,g = func(x)
    if verbose:
        print '%d\t%.5f\t%.5f'%(0, f, np.linalg.norm(g))
    #for i in range(1, max_iter):
    hist = [f]
    i = 0
    while i < max_iter:
        x_new = x - gamma*g
        [f_new, g_new] = func(x_new)
        if f_new <= f:
            i = i + 1
            if verbose:
                print '%d\t%.5f\t%.5f'%(i, f_new, np.linalg.norm(g_new))
            change = f - f_new
            x = x_new
            f = f_new
            g = g_new
            hist.append(f)
            if change < tol:
                print 'Stopped since function val change below tol'
                break
            gamma = gamma*2.0
        else:
            gamma = gamma/2.0
    return [x,f,hist]
            
